
sub DetectPGversion
{
        $sth=$dbh->prepare("SELECT VERSION()");
	$sth->execute || return;
	$ver = $sth->fetchrow_array;
	$ver =~ m/PostgreSQL (\d).(\d).(\d)/g;
	return int("$1$2$3"), "$1.$2.$3";
}

sub DetectULockAdminTable
{
	return 1 if $CACHED;

	$CACHED = 1;
	my @tables = $dbh->tables;

	foreach $table (@tables) {
		return 1 if ($table eq 'admin_locktext')
	}

	$CACHED = 0;
	return;
}

sub CreateULockAdminTable
{
	my $SQL = qq|
	CREATE TABLE admin_locktext (
	  luin float8 NOT NULL, 
	  admin_uin float8 NOT NULL, 
	  "admin_lck_text" text NOT NULL, 
	  CONSTRAINT "<unnamed>" FOREIGN KEY (luin) REFERENCES users_lock (luin) ON DELETE CASCADE ON UPDATE NO ACTION NOT DEFERRABLE INITIALLY IMMEDIATE
	) WITH OIDS;
	CREATE INDEX "admin_locktext_luin_key" ON "admin_locktext"("luin"); 
	CREATE INDEX "admin_locktext_admin_uin_key" ON "admin_locktext"("admin_uin")|;

	$rv=$dbh->do($SQL);

	return (($DBI::errstr) ? $DBI::errstr : 1);
}

sub DropULockAdminTable
{
	$rv=$dbh->do("DROP TABLE admin_locktext");
	return (($DBI::errstr) ? $DBI::errstr : 1);
}

sub PrintRegForm
{
	my ( $uin,
             $pass,
             $nick,
             $frst,
             $last,
             $email,
             $sex,
             $regreq,
             $show_pass,
	     $pass
           ) = @_;

	my ($a, $b, $c);

	if ($sex == 1)
	{
		$a="selected";
	}
	elsif ($sex == 2)
	{
		$b="selected";
	}
	else
	{
		$c="selected";
	}

	if ($show_pass) {
		$pass_field = "TEXT";
	} else {
		$pass_field = "PASSWORD";
	}

	print qq|	<FORM ACTION="isdwm.cgi" METHOD="GET">
	<INPUT TYPE="hidden" NAME="do" VALUE="submit">
	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100%>
		<tr bgcolor=$TableColorStrip><td colspan=2 align=center><b>$Language{phrase172}</b></td>
		<tr bgcolor=$TableColor><td>UIN:</td><td><INPUT TYPE="HIDDEN" NAME="action" VALUE="adduser"><INPUT TYPE="text" NAME="uin" SIZE="8" VALUE="$uin" $InputParam> </td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase1}:</td><td><INPUT TYPE="$pass_field" NAME="password" SIZE="8" MAXLENGTH="8" VALUE="$pass" $InputParam> </td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase25}:</td><td><INPUT TYPE="text" NAME="nick" VALUE="$nick" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase49}:</td><td><INPUT TYPE="text" NAME="frst" VALUE="$frst" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase50}:</td><td><INPUT TYPE="text" NAME="last" VALUE="$last" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase51}:</td><td><INPUT TYPE="text" NAME="email" VALUE="$email" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase213}:</td><td><SELECT NAME="sex" $InputParam><OPTION VALUE="2" $b>$Language{phrase214}<OPTION value="1" $a>$Language{phrase215}<OPTION value="0" $c>$Language{phrase212}</SELECT></td></tr>|;
	if ($mail_reg eq "yes") { print qq|		<tr bgcolor=$TableColor><td>$Language{phrase186}:</td><td><INPUT TYPE="checkbox" NAME="sendmail" $InputParam> $Language{phrase187}</td></tr>|;}
		print qq|		<tr bgcolor=$TableColor><td>$Language{phrase168}:</td><td><INPUT TYPE="checkbox" NAME="cpass" CHECKED $InputParam> $Language{phrase207}</td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase167}:</td><td><INPUT TYPE="checkbox" NAME="auth" $InputParam> $Language{phrase173}</td></tr>|;
	if (defined $regreq)
		{
			print qq|		<tr bgcolor=$TableColor><td>$Language{phrase65}:</td><td><INPUT TYPE="checkbox" NAME="regreq" VALUE="true" checked $InputParam> $Language{phrase60}</td></tr>
			<INPUT TYPE="hidden" NAME="ruin" VALUE="$in{ruin}">|;
		}
	print <<HTML__;
		<tr bgcolor=$TableColor><td>&nbsp;</td><td><INPUT TYPE="submit" NAME="submit" VALUE="$Language{phrase208}" $InputParam> <INPUT TYPE="RESET" NAME="Reset" VALUE="$Language{phrase166}" $InputParam></td></tr>
	</table>
	</FORM>

HTML__
}

sub PrintEntryExit
{
	print "\n";
	$title = shift;
print <<HTML__;
<html>
<head>
<style type="text/css">
INPUT {
	background-color : $InputBGColor;
	border: solid  Black 1;
	font : 9pt Arial;
	height : 14pt;
}
BODY, TD {
$BodyTDStyle
}
</style>
<title>$title</title>
<meta http-equiv="Content-Type" content="text/html; $WebCodepage">
</head>
<body bgcolor="$BGColor" text="$TextColor">
<div align="center">
        <img src="$URLToImages/isdwmlogo.gif" width="180" height="60">
HTML__
}

sub GetFreeUIN
{
	if ($FirstFreeUIN eq "yes")
	{
		$sth=$dbh->prepare("SELECT uin FROM users_info_ext WHERE (uin<=$MaxAddUIN AND uin>=$MinAddUIN) ORDER BY uin");
		$sth->execute;
		$prevUIN=0;
		$FreeUIN=0;
		while ($hash_ref = $sth->fetchrow_hashref and $FreeUIN == 0)
		{
			if ($prevUIN!=0) 
			{
				if ($hash_ref->{uin}-$prevUIN > 1 ) {$FreeUIN=++$prevUIN;}
			};
			$prevUIN=$hash_ref->{uin};
		}
		return $FreeUIN;
	}
        $sth=$dbh->prepare("SELECT MAX (uin) from users_info_ext WHERE (uin<$MaxAddUIN and uin>$MinAddUIN)");
	$sth->execute;
	my $MaxUIN = $sth->fetchrow_array;
	return ++$MaxUIN;
}

sub WriteUser
{
	my ($uin, $nick, $fname, $lname,$pass, $email, $llog, $status) = @_;
	$llog = sprintf ("%02d.%02d.%d", ($t = localtime($llog))->mday, $t->mon+1, $t->year+1900);
	print qq(<tr bgcolor = $TableColor><td align=center><a href="isdwm.cgi?action=edituin&uin=$uin">$uin</a></td><td>$nick</td><td>$fname</td><td>$lname</td><td width=1><font color="$TableColor" title="$pass"><nobr>$pass</nobr></font></td><td width="1">$email</td><td width="1">$llog</td><td align=center>);
	if (defined $status)
	{
		defined $OnlineStatus{$status} ? &PrintOnlineStatus ($status) : &PrintOnlineStatus (257);
	}
	else
	{
		&PrintOnlineStatus (258);
	}
	print "</td></tr>\n";
}

sub PrintOnlineStatus
{
	my $status = shift;
	print qq(<img src="$URLToImages/$OnlineStatus{$status}->[0]" border=0 width="16" height="16" alt="$OnlineStatus{$status}->[1]">);
}

sub GetIP
{
	use Socket;
	$_[0] = inet_ntoa(pack("L", $_[0]));
}

sub Setup
{
	my $CallStatus = shift;
	&PrintHeader ("$Language{phrase94}");
	if ($CallStatus == 1)
	{
		$AddOn = "<tr bgcolor=$TableColor><td colspan=2><b>$Language{phrase99}</b></td>"
	}
        elsif ($CallStatus == 2)
	{
		$AddOn = "<tr bgcolor=$TableColor><td colspan=2><b>$Language{phrase100}</b></td>"
	}
   	elsif ($CallStatus == 3){
		$AddOn = "<tr bgcolor=$TableColor><td colspan=2><b>$Language{phrase101}</b></td>"
	}

	&PrintMenu(100);
	$AdminMail ||= $ENV{'SERVER_ADMIN'};

	print qq|
	<FORM ACTION="isdwm.cgi" METHOD="POST">
	<INPUT TYPE="hidden" NAME="action" VALUE="savesettings">
	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100%>
		<tr bgcolor=$TableColorStrip><td colspan=2><B>$Language{phrase108}</B></td>
		$AddOn
		<tr bgcolor=$TableColor><td>$Language{phrase114}</td><td>$DBI::VERSION/$DBD::Pg::VERSION</td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase221}</td><td>$PGv_srt</td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase224}</td><td><SELECT name="language" $InputParam>
|;
		foreach (&ReadLanguages) {
			print qq|<OPTION value="$_"| . (($_ eq $language) ? " selected" : "") .qq|>$_|;
		}
		
	print qq|</SELECT></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase126}</td><td><INPUT TYPE="TEXT" NAME="Admins" VALUE="$Admins" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase112}</td><td><INPUT TYPE="TEXT" NAME="ISD_pid" VALUE="$ISD_pid" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase113}</td><td><INPUT TYPE="CHECKBOX" NAME="mail_reg" VALUE="yes"|; if ($mail_reg eq "yes") {print " checked";} print qq|></td></tr>|;
		
		print qq|
		<tr bgcolor=$TableColor><td>$Language{phrase117}</td><td><INPUT TYPE="TEXT" NAME="default_pass" VALUE="$default_pass" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase118}</td><td><INPUT TYPE="TEXT" NAME="default_nick" VALUE="$default_nick" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase119}</td><td><INPUT TYPE="TEXT" NAME="default_frst" VALUE="$default_frst" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase120}</td><td><INPUT TYPE="TEXT" NAME="default_last" VALUE="$default_last" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase121}:<br><INPUT TYPE="TEXT" NAME="default_lock_text" SIZE="85" VALUE="$default_lock_text" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase122}</td><td><INPUT TYPE="TEXT" NAME="MinAddUIN" VALUE="$MinAddUIN" SIZE="5" $InputParam> - <INPUT TYPE="TEXT" NAME="MaxAddUIN" VALUE="$MaxAddUIN" SIZE="5" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase123}</td><td><INPUT TYPE="CHECKBOX" NAME="FirstFreeUIN" VALUE="yes"|; if ($FirstFreeUIN eq "yes") {print " checked";} print qq|></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase245}</td><td><INPUT TYPE="CHECKBOX" NAME="ShowOnlyOffMess" VALUE="yes"|; if ($ShowOnlyOffMess) {print " checked";} print qq|></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase124}</td><td><INPUT TYPE="TEXT" NAME="URLToImages" VALUE="$URLToImages" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase127}</td><td><INPUT TYPE="TEXT" NAME="MaxPageItems" VALUE="$MaxPageItems" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase128}</td><td><INPUT TYPE="TEXT" NAME="sendmailprog" VALUE="$sendmailprog" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase223}:<BR><TEXTAREA NAME="MailHeader" ROWS=5 COLS=65 $InputParam>$MailHeader</TEXTAREA></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase129}:</td><td><INPUT TYPE="TEXT" NAME="AdminMail" VALUE="$AdminMail" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase130}:<br><INPUT TYPE="TEXT" NAME="MailRegSubject" SIZE="85" VALUE="$MailRegSubject" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase131}:<BR><TEXTAREA NAME="MailTextSubject" ROWS=5 COLS=65 $InputParam>$MailTextSubject</TEXTAREA><br>$Language{phrase188}</td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase132}</td><td><INPUT TYPE="TEXT" NAME="MainTableSize" VALUE="$MainTableSize" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase133}</td><td><INPUT TYPE="TEXT" NAME="LeftTableSize" VALUE="$LeftTableSize" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase134}</td><td><INPUT TYPE="TEXT" NAME="InputBGColor" VALUE="$InputBGColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase135}</td><td><INPUT TYPE="TEXT" NAME="InputMouseOver" VALUE="$InputMouseOver" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase136}</td><td><INPUT TYPE="TEXT" NAME="TableBorderColor" VALUE="$TableBorderColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase137}</td><td><INPUT TYPE="TEXT" NAME="TableColor" VALUE="$TableColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase138}</td><td><INPUT TYPE="TEXT" NAME="RightTablesCellPadding" VALUE="$RightTablesCellPadding" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase139}</td><td><INPUT TYPE="TEXT" NAME="MainTableColor" VALUE="$MainTableColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase140}</td><td><INPUT TYPE="TEXT" NAME="MainTableCellPadding" VALUE="$MainTableCellPadding" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase141}</td><td><INPUT TYPE="TEXT" NAME="TableColorStrip" VALUE="$TableColorStrip" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase142}</td><td><INPUT TYPE="TEXT" NAME="TextColor" VALUE="$TextColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase143}</td><td><INPUT TYPE="TEXT" NAME="BGColor" VALUE="$BGColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase144}</td><td><INPUT TYPE="TEXT" NAME="MenuSelectedColor" VALUE="$MenuSelectedColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase145}</td><td><INPUT TYPE="TEXT" NAME="MenuOverColor" VALUE="$MenuOverColor" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase146}</td><td><INPUT TYPE="TEXT" NAME="WebCodepage" VALUE="$WebCodepage" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td>$Language{phrase147}</td><td><INPUT TYPE="TEXT" NAME="MenuCellPadding" VALUE="$MenuCellPadding" $InputParam></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase148}<BR><TEXTAREA NAME="BodyTDStyle" ROWS=5 COLS=65 $InputParam>$BodyTDStyle</TEXTAREA></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase149}<BR><TEXTAREA NAME="ALink" ROWS=5 COLS=65 $InputParam>$ALink</TEXTAREA></td></tr>
		<tr bgcolor=$TableColor><td colspan=2>$Language{phrase150}<BR><TEXTAREA NAME="AHover" ROWS=5 COLS=65 $InputParam>$AHover</TEXTAREA></td></tr>
		<tr bgcolor=$TableColor><td colspan=2 align="center"><br><INPUT TYPE="SUBMIT" VALUE="$Language{phrase151}" $InputParam></td></tr>
		</TABLE>
		</FORM>|;

	&PrintFooter; exit;
};

sub LoadConfig
{
	$CurrentConfig = $config_version;

	eval {
		do "isdwm.conf";
	} || ($READ_ERROR = 1);

	&LoadLanguage($def_language);
	&LoadLanguage($language) if ($def_language ne $language);

	if ($READ_ERROR)
	{
		$default_nick      = $Language{phrase230};
		$default_frst      = $Language{phrase231};
		$default_last      = $Language{phrase232};
		$default_lock_text = $Language{phrase233};
		$MailRegSubject    = $Language{phrase234};
		$MailTextSubject   = $Language{phrase235};
		$MailRegSubject    = $Language{phrase236};
		$WebCodepage       = $Language{phrase240};
		$MailHeader        = $Language{phrase241};

		&Setup(1) unless ($in{'action'} eq "savesettings");
	}
}

sub SaveSettings
{
	foreach (keys %in)
	{
		$in{$_}=~s/\|/\\|/g if $in{$_} =~/[^\\]\|/g;
	}

	open (CONFIG, ">isdwm.conf") or die "$!";

	print CONFIG <<CONF__;
# IServerd Web Manager configuration file

\$config_version         = $config_version;
\$language               = q|$in{language}|;
\$Admins                 = q|$in{Admins}|;
\$MaxPageItems           = q|$in{MaxPageItems}|;
\$MailHeader             = q|$in{MailHeader}|;
\$AdminMail              = q|$in{AdminMail}|;
\$MainTableSize          = q|$in{MainTableSize}|;
\$LeftTableSize          = q|$in{LeftTableSize}|;
\$InputBGColor           = q|$in{InputBGColor}|;
\$InputMouseOver         = q|$in{InputMouseOver}|;
\$TableBorderColor       = q|$in{TableBorderColor}|;
\$TableColor             = q|$in{TableColor}|;
\$RightTablesCellPadding = q|$in{RightTablesCellPadding}|;
\$MainTableColor         = q|$in{MainTableColor}|;
\$MainTableCellPadding   = q|$in{MainTableCellPadding}|;
\$TableColorStrip        = q|$in{TableColorStrip}|;
\$BGColor                = q|$in{BGColor}|;
\$MenuSelectedColor      = q|$in{MenuSelectedColor}|;
\$MenuOverColor          = q|$in{MenuOverColor}|;
\$WebCodepage            = q|$in{WebCodepage}|;
\$MenuCellPadding        = q|$in{MenuCellPadding}|;
\$sendmailprog           = q|$in{sendmailprog}|;
\$BodyTDStyle            = q|$in{BodyTDStyle}|;
\$ALink                  = q|$in{ALink}|;
\$AHover                 = q|$in{AHover}|;
\$ISD_pid                = q|$in{ISD_pid}|;
\$mail_reg               = q|$in{mail_reg}|;
\$default_pass           = q|$in{default_pass}|;
\$default_nick           = q|$in{default_nick}|;
\$default_frst           = q|$in{default_frst}|;
\$default_last           = q|$in{default_last}|;
\$default_lock_text      = q|$in{default_lock_text}|;
\$MaxAddUIN              = $in{MaxAddUIN}; 
\$MinAddUIN              = $in{MinAddUIN};
\$FirstFreeUIN           = q|$in{FirstFreeUIN}|;
\$ShowOnlyOffMess        = q|$in{ShowOnlyOffMess}|;
\$URLToImages            = q|$in{URLToImages}|;
\$TextColor              = q|$in{TextColor}|;
\$MailRegSubject         = q|$in{MailRegSubject}|;
\$MailTextSubject        = q|$in{MailTextSubject}|;
\$MailHeader             = q|$in{MailHeader}|;
1;
CONF__
	close(CONFIG);
	chmod (0600, "isdwm.conf");
}

1;