#!/usr/bin/perl

use DBI;
use DBD::Pg;
use Time::Local;
use Time::localtime;

require "include/common.pl";
require "include/defaults.pl";
require "include/connect.pl";
require "include/lang.pl";
require "include/http.pl";
require "include/page.pl";

$Title = "IServerd Web Manager Installation Script";

if (-f $database_info)
{
	print qq|location: isdwm.cgi\n\n|;
	exit;
}

if ($in{'go'} eq 'step3')
{
	&Lang;
	&CheckConnect;
	&PrintSimpleHeader($Title);
	print $Language{phrase238};
	&WriteConnectInfo;
	&PrintSimpleFooter;
	exit;
	
}

if ($in{'go'} eq 'step2')
{
	&Lang;
	&Step2;
}

&Step1;

sub Step1
{
	&PrintSimpleHeader($Title);
	print qq|
     <FORM ACTION="install.cgi" METHOD="POST">
     <table width="100%" border="0" cellspacing="1" cellpadding="1" align="center">
       <tr bgcolor=$TableColor>
          <td align="center">Choose Your Language:</td>
          <td><SELECT name="language">
|;
		foreach (&ReadLanguages) {
			print qq|<OPTION value="$_">$_\n|;
		}
	print qq|</SELECT>
	     <INPUT TYPE="hidden" NAME="go" VALUE="step2">
          </td>
        </tr>
        <tr>
          <td colspan="2" align="center"><INPUT TYPE="submit" VALUE="NEXT"></td>
       </tr>
     </table>
     </FORM>|;
	&PrintSimpleFooter;

}

sub Step2
{
	&PrintSimpleHeader($Title);
	print qq|
     <FORM ACTION="install.cgi" METHOD="POST">
     <table width="100%" border="0" cellspacing="1" cellpadding="1" align="center">
	<tr bgcolor=$TableColor><td>$Language{phrase222}<br><small>$Language{phrase239}</small></td><td><INPUT TYPE="TEXT" NAME="db_host" VALUE="$db_host" $InputParam></td></tr>
	<tr bgcolor=$TableColor><td>$Language{phrase237}</td><td><INPUT TYPE="TEXT" NAME="db_port" VALUE="$db_port" $InputParam></td></tr>
	<tr bgcolor=$TableColor><td>$Language{phrase109}</td><td><INPUT TYPE="TEXT" NAME="db_name" VALUE="$db_name" $InputParam></td></tr>
	<tr bgcolor=$TableColor><td>$Language{phrase110}</td><td><INPUT TYPE="TEXT" NAME="db_user" VALUE="$db_user" $InputParam></td></tr>
	<tr bgcolor=$TableColor><td>$Language{phrase111}</td><td><INPUT TYPE="TEXT" NAME="db_pass" VALUE="$db_pass" $InputParam></td></tr>
        <INPUT TYPE="hidden" NAME="go" VALUE="step3">
        <INPUT TYPE="hidden" NAME="language" VALUE="$language">
	<tr>
	  <td colspan="2" align="center"><INPUT TYPE="submit" VALUE="$Language{phrase178}"></td>
	</tr>
      </table>
      </FORM>|;
	&PrintSimpleFooter;
	exit;
}

sub Lang
{
	$language = $in{'language'};

	exit unless (-f "language/$language");

	&LoadLanguage($def_language);
	&LoadLanguage($language) if ($def_language ne $language);
}

sub CheckConnect
{
	$STATUS = &dbConnect ($in{'db_name'}, $in{'db_host'}, $in{'db_port'}, $in{'db_user'}, $in{'db_pass'});

	if ($STATUS != 1)
	{
		&PrintSimpleHeader ("$Language{phrase34}");
		print qq|<h3 align="center">$Language{phrase226}<br>$Language{phrase227}<br>$Language{phrase228}|;
		print "<br>$STATUS";
		&PrintSimpleFooter;
		exit;
	}
	return 1;
}

sub WriteConnectInfo
{
	open (DATABASE_CONFIG, ">$database_info") or return $!;

	foreach (keys %in)
	{
		$in{$_}=~s/\|/\\|/g if $in{$_} =~/[^\\]\|/g;
	}

	print DATABASE_CONFIG <<TEXT__;
# IServerd Web Manager Database Configuration

\$db_host  = q|$in{db_host}|;
\$db_port  = q|$in{db_port}|;
\$db_name  = q|$in{db_name}|;
\$db_user  = q|$in{db_user}|;
\$db_pass  = q|$in{db_pass}|;
\$language = q|$in{language}|;
TEXT__

	close (DATABASE_CONFIG);
	chmod (0600, "$database_info");
}



