#!/usr/bin/perl

use DBI;
use DBD::Pg;
use Time::Local;
use Time::localtime;

require "include/common.pl";
require "include/defaults.pl";
require "include/connect.pl";
require "include/http.pl";
require "include/lang.pl";
require "include/cookies.pl";
require "include/page.pl";
require "include/auth.pl";
require "include/functions.pl";

eval {
	do "$database_info"
};

if ($!)
{
	&LoadLanguage($def_language);
	&PrintSimpleHeader;
	print qq|<br><div align="center">$Language{phrase229}</div>|;
	&PrintSimpleFooter;
	exit;
}
	&LoadConfig;

	$STATUS = &dbConnect ($db_name, $db_host, $db_port, $db_user, $db_pass);

	$PGv, $PGv_srt = &DetectPGversion;


	if ($STATUS != 1)
	{
		&PrintSimpleHeader ("$Language{phrase34}");
		print qq|$Language{phrase226}|;
		print "<br>$STATUS";
		&PrintSimpleFooter;
		exit;
	}

	&Setup(2) if (!$in{'Admins'} && ($in{'action'} eq "savesettings"));

	if (($in{'action'} eq "savesettings") && (&CheckAdminAccess ($cook{'adminuin'}, $cook{'adminpass'}) || !(-f "isdwm.conf")))
	{
		&SaveSettings;
		&LoadConfig;
	}
		

	%MenuItems = (
		10  =>  (["$Language{phrase153}", ""]),
		20  =>  (["$Language{phrase154}", "adduser"]),
		30  =>  (["$Language{phrase62}",  "list"]),
#		35  =>  ([" ",  "sysmess"]),
		40  =>  (["$Language{phrase155}", "deluser"]),
		50  =>  (["$Language{phrase156}", "lockuser"]),
		60  =>  (["$Language{phrase157}", "newlock"]),
		70  =>  (["$Language{phrase158}", "regreq"]),
		80  =>  (["$Language{phrase159}", "online"]),
		90  =>  (["$Language{phrase160}", "offmess"]),
		95  =>  (["$Language{phrase246}", "vacuum"]),
		100 =>  (["$Language{phrase161}", "setup"]),
		110 =>  (["$Language{phrase162}", "exit"])
	);

	%OnlineStatus = (
		0  =>  (["online.gif", "Online"]),
		1  =>  (["away.gif", "Away"]),
		2  =>  (["dnd.gif", "DND"]),
		4  =>  (["na.gif", "N/A"]),
		5  =>  (["na.gif", "N/A"]),
		16 =>  (["occupied.gif", "Occupied"]),
		17 =>  (["dnd.gif", "DND"]),
		32 =>  (["ffc.gif", "Free For Chat"]),
		256=>  (["invisible.gif", "Invisible"]),
		257=>  (["status.gif", "Unknown"]),
		258=>  (["offline.gif", "Offline"])
	);

	%DesktopStatus = ( #   ?  -...
		 -1 =>  (["systray.gif", "$Language{phrase163}"]),
		 0  =>  (["unknown.gif", "$Language{phrase164}"]),
		 1  =>  (["desktop.gif", "$Language{phrase165}"])
	);

	print "Content-type: text/html; charset=$WebCodepage\n";

	if ($CurrentConfig != $config_version) { &Setup(3) };

	$InputParam = qq(Onmouseover="this.style.backgroundColor='$InputMouseOver'"; onmouseout="this.style.backgroundColor='$InputBGColor'";);

#########################################
# TRACE vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
#
#	DBI->trace (2, '/tmp/isdwm.txt');
#
#       ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#########################################

	unless ((&CheckAdminAccess ($in{'adminuin'}, $in{'adminpass'})) || (&CheckAdminAccess ($cook{'adminuin'}, $cook{'adminpass'})))
	{
		&PrintEntryExit("$Language{phrase4}");
		print <<HTML__;
	<table border=0 bgcolor=$TableBorderColor cellpadding=3 cellspacing=1 width=220>
	<FORM ACTION="isdwm.cgi" METHOD="POST" name="login">
	  <tr bgcolor=$TableColorStrip><td colspan=2 align=center>$Language{phrase3}</td></tr>
	  <tr bgcolor=$TableColor><td width="120">UIN:</td><td><INPUT TYPE="text" NAME="adminuin" SIZE="8" $InputParam></td></tr>
	  <tr bgcolor=$TableColor><td width="120">$Language{phrase1}</td><td><INPUT TYPE="password" SIZE="8" NAME="adminpass" $InputParam></td></tr>
          <tr bgcolor=$TableColor><td width="120">$Language{phrase7}</td><td><INPUT TYPE="CHECKBOX" NAME="remember" $InputParam></td></tr>
          <tr bgcolor=$TableColor><td width="120">&nbsp;</td><td><INPUT TYPE="SUBMIT" VALUE="&nbsp;&nbsp;&nbsp;$Language{phrase2}&nbsp;&nbsp;&nbsp;" $InputParam></td></tr>
	</FORM>
	</table>
	<br>
	$Copyright<br>$Copyright_local
	<SCRIPT LANGUAGE="JavaScript">
	<!-- HIDE
	document.login.adminuin.focus();
HTML__
	if ($in{adminuin} || $in{adminpass})
	{
        print <<HTML__;
alert('$Language{phrase170}');
HTML__
	}
    print <<HTML__;
	// STOP HIDING FROM OTHER BROWSERS -->
	</SCRIPT>
	</td><tr></table>
	</body>
	</HTML>
HTML__
exit;
	}
	else
	{
	        if ($in{'adminuin'} && $in{'adminpass'})
		{

     			&SetCookies("adminuin","$in{adminuin}");
			&SetCookies("adminpass","$in{adminpass}");
	     		print "\n";
		}
	}

if ($in{'action'} eq 'create_admin_lck_table')
{
	$RESULT = &CreateULockAdminTable;

	if ($RESULT == 1)
	{
		print "location: $ENV{'HTTP_REFERER'}\n\n";
		exit;
	}
	else
	{
		&PrintSimpleHeader;
		print $RESULT;
		&PrintSimpleFooter;
		exit;
	}
}

if ($in{'action'} eq 'drop_admin_lck_table')
{
	$RESULT = &DropULockAdminTable;

	if ($RESULT == 1)
	{
		print "location: $ENV{'HTTP_REFERER'}\n\n";
		exit;
	}
	else
	{
		&PrintSimpleHeader;
		print $RESULT;
		&PrintSimpleFooter;
		exit;
	}
}


if ($in{'action'} eq 'vacuum')
{
	$rv=$dbh->do("VACUUM FULL ANALYZE");
	print "location: isdwm.cgi\n\n";
	exit;
}

if ($in{'action'} eq 'offmess')
{
	&PrintHeader ("$Language{phrase11}");
	&PrintMenu (90);

        if (exists $in{'datefrom'}) 
	{
		($datefrom = $in{'datefrom'}) =~ s/(\d+).(\d+).(\d+)/timelocal(0,0,0,$1,$2-1,$3-1900)/ge;

		unless (defined $datefrom) 
		{
			print "UIN $in{uin}: $Language{phrase5}: <b>$in{datefrom}</b>. $Language{phrase6}.";
			&PrintFooter;
			exit;
		}

		($dateto=$in{'dateto'}) =~ s/(\d+).(\d+).(\d+)/timelocal(59,59,23,$1,$2-1,$3-1900)/ge;

		unless (defined $dateto) 
		{
			print "UIN $in{uin}: $Language{phrase5}: <b>$in{dateto}</b>. $Language{phrase6}.";
			&PrintFooter;
			exit;
		}

		$addon="WHERE (msg_date>$datefrom AND msg_date<$dateto)";

	        if (exists $in{'del'}) 
		{
			$rv=$dbh->do("DELETE FROM users_messages $addon");
			print "$Language{phrase8} $Language{phrase9} $in{datefrom} $Language{phrase10} $in{dateto}.";
			&PrintFooter;
			exit;
		}
		$urlsearch = "&show=&datefrom=$in{datefrom}&dateto=$in{dateto}";
	}
	elsif ($in{do} eq "search")
	{
		$addon="WHERE msgtext ILIKE '\%$in{search}\%'";
		$urlsearch = "&do=search&search=$in{search}";
	}	
	if ($in{sort} eq "to_uin") { $sort="ORDER BY to_uin" }
		elsif ($in{sort} eq "from_uin") { $sort="ORDER BY from_uin" }
			elsif ($in{sort} eq "msg_type") { $sort="ORDER BY msg_type" }
				else { $sort="ORDER BY msg_date" };
	if (!$in{page}) {$in{page}=0;} else {$in{page}--};

	$PageS = $in{page}+1;

	if ($ShowOnlyOffMess)
	{
		$addon ? ($addon .= ' AND msg_type=1') : ($addon = 'WHERE msg_type=1');
	}

	$LIMIT = qq(LIMIT $MaxPageItems OFFSET ).$MaxPageItems*$in{page};
	$sth=$dbh->prepare("SELECT COUNT(to_uin) from users_messages $addon");
	$sth->execute;
	$TotalByQuery = $sth->fetchrow;

	$sth=$dbh->prepare("SELECT * FROM users_messages $addon $sort DESC $LIMIT ");
	$sth->execute;

	for ($i = 1; $i<($TotalByQuery/$MaxPageItems)+1; $i++) 
	{
		if ($PageS != $i) 
		{
			$page .= qq(<a href="isdwm.cgi?action=offmess&sort=$in{sort}&page=$i$urlsearch"><b>$i</b></a> );
		}
			else
		{
			$page .= "<b>$i </b>";
		}
	}

	print qq|
	<FORM ACTION="isdwm.cgi" METHOD="GET">
	<INPUT TYPE="hidden" NAME="action" VALUE="offmess">
	<table border=0 bgcolor="$TableBorderColor" cellpadding="$RightTablesCellPadding" cellspacing="1" width="100%">
	<tr bgcolor=$TableColorStrip><td colspan=5 align=center><b>$Language{phrase11}</b></td></tr>
	<tr bgcolor=$TableColorStrip><td colspan=5>$Language{phrase12}: $Language{phrase9} <INPUT TYPE="text" NAME="datefrom" SIZE="10" VALUE="$in{datefrom}" $InputParam> $Language{phrase10} <INPUT TYPE="text" NAME="dateto" VALUE="$in{dateto}" SIZE="10" $InputParam> <INPUT TYPE="SUBMIT" NAME="show" VALUE="$Language{phrase14}" $InputParam> <INPUT TYPE="SUBMIT" NAME="del" VALUE="$Language{phrase15}" $InputParam> <small>($Language{phrase16})</small></td></tr></form>
	<FORM ACTION="isdwm.cgi" METHOD="GET">
	<INPUT TYPE="hidden" NAME="action" VALUE="offmess">
	<INPUT TYPE="hidden" NAME="do" VALUE="search">
	<tr bgcolor=$TableColorStrip><td colspan=5>$Language{phrase13}: <INPUT TYPE="text" NAME="search" SIZE="10" VALUE="$in{search}" $InputParam> <INPUT TYPE="SUBMIT" VALUE="$Language{phrase18}" $InputParam></td></tr>
	</FORM>
	<tr bgcolor=$TableColorStrip align="center"><td><a href="isdwm.cgi?action=offmess&page=1$urlsearch"><b>$Language{phrase17}</b></td><td width=1><a href="isdwm.cgi?action=offmess&sort=from_uin&page=1$urlsearch"><nobr><b>$Language{phrase216}</b></nobr></a></td><td width=1><a href="isdwm.cgi?action=offmess&sort=to_uin&page=1$urlsearch"><nobr><b>$Language{phrase22} (UIN)</b></nobr></a></td><td width=1><a href="isdwm.cgi?action=offmess&sort=msg_type&page=1$urlsearch"><b>$Language{phrase42}</b></a></td><td><b>$Language{phrase21}</b></td></tr>|;
	if ($sth->rows != 0)
	{
		while (@rows=$sth->fetchrow)
		{
			print qq|<tr bgcolor=$TableColor align="center"><td heigth="1"><nobr>|.sprintf ("%02d:%02d <b>%02d.%02d.%d</b>",($t = localtime($rows[2]))->hour, $t->min, $t->mday, $t->mon+1, $t->year+1900).qq|</nobr></td><td align="center"><a href="isdwm.cgi?action=edituin&uin=$rows[1]">$rows[1]</a></td><td><a href="isdwm.cgi?action=edituin&uin=$rows[0]">$rows[0]</a></td><td>|;
			if ($rows[3]==1)
			{
				print qq(<img src="$URLToImages/message.gif" border=0 width="16" height="16" alt="Message">);
				$msg="$rows[4]";
			}
			elsif ($rows[3]==4)
			{
				print qq(<img src="$URLToImages/url.gif" border=0 width="16" height="16" alt="URL">);
				$msg = sprintf("$Language{phrase24}: %s<br>URL: <a href=\"%s\">%s </a>", (@_=split(//,$rows[4])), $_[1]);
			}
			elsif ($rows[3]==6)
			{
				print qq(<img src="$URLToImages/auth.gif" border=0 width="16" height="16" alt="Authorise">);
				$msg = sprintf("%s %s %s %s", (@_=split(//,$rows[4])));
			}
			elsif ($rows[3]==12)
			{
				print qq(<img src="$URLToImages/regreq.gif" border=0 width="16" height="16" alt="Registration request">);
				$msg = sprintf("%s %s %s %s", (@_=split(//,$rows[4])));
			}
			elsif ($rows[3]==20)
			{
				print qq(<img src="$URLToImages/system.gif" border=0 width="16" height="16" alt="System message">);
				$msg = sprintf("%s %s %s %s %s %s", (@_=split(//,$rows[4])));
			}
			elsif ($rows[3]==13)
			{
				print qq(<img src="$URLToImages/web.gif" border=0 width="16" height="16" alt="Web message">);
				$msg = $rows[4];
			}
			else 
			{
				print qq(<img src="$URLToImages/status.gif" border=0 width="16" height="16" alt="$Language{phrase44} [$rows[3]]">);
				$msg = $rows[4];
			}	
			print qq|</td><td align="left">$msg</td></tr>|;
		}
	}
	print qq|<tr><td colspan=5>$Language{phrase19}: $page</td></tr></table>|;
	&PrintFooter; exit;
}	

if ($in{action} eq "online")
{
	$REFRESH = 30;

	&PrintHeader ("$Language{phrase220}");
	&PrintMenu (80);

	$sth=$dbh->prepare("SELECT online_users.uin,online_users.iadr,online_users.stat,online_users.uptm,online_users.prv,online_users.state,users_info_ext.nick from online_users,users_info_ext where online_users.uin=users_info_ext.uin ORDER BY uin");

	$sth->execute;
	$count=$sth->rows;


	print qq|
	<table border=0 bgcolor="$TableBorderColor" cellpadding="$RightTablesCellPadding" cellspacing="1" width="100%">
	<tr bgcolor=$TableColorStrip><td colspan=7 align=center><b>$Language{phrase20} ($count)</b></td></tr>
	<tr bgcolor=$TableColor align=center><td><b>UIN</b></td><td><b>NICK</b></td><td><b>IP</b></td><td><b>V</b></td><td><b>$Language{phrase76}</b></td><td><b>$Language{phrase45}</b></td><td><b><img src="$URLToImages/status.gif" border=0 width="16" height="16" alt="$Language{phrase43}"></b></td></tr>|;
	while (@rows=$sth->fetchrow)
	{
		$rows[3] = int((time-$rows[3])/60);
		&GetIP($rows[1]);

		print qq|<tr bgcolor=$TableColor align=center><td><a href="isdwm.cgi?action=edituin&uin=$rows[0]">$rows[0]</a></td><td>$rows[6]</td><td align=left>$rows[1]</td><td>$rows[4]</td><td>$rows[3]</td><td>|;
		if ($rows[4] == 3) {  print qq|<img src="$URLToImages/$DesktopStatus{$rows[5]}->[0]" border=0 width="16" height="16" alt="$DesktopStatus{$rows[5]}->[1] [$rows[5]]">| }
		else { print "-" }; print "</td><td>";
		&PrintOnlineStatus($rows[2]); 
		print qq|</td></tr>|;
	}
	print "</table>";
	&PrintFooter; exit;
}
if ($in{action} eq "edituin") 
{

	if ($in{do} eq "submit")
	{
		$in{llog} =~ s/(\d{2}):(\d{2}) (\d{2}).(\d{2}).(\d{4})/$llog_time = timelocal(0,$2,$1,$3,$4-1,$5-1900)/ge;

		$in{bthd} =~ s/(\d{2}).(\d{2}).(\d{2,4})/{ ($3 > 1000) ? ($byear = $3-1900) : ($byear = $3); $bday=$1; $bmon=$2 }/ge;

		unless (defined $llog_time) 
		{
			&PrintHeader ("$Language{phrase26} #$in{uin}");
			&PrintMenu (30);
			print "UIN $in{uin}:$Language{phrase28}. $Language{phrase29}: <b>$in{llog}</b>. $Language{phrase30}.";
			&PrintFooter;
			exit;

		}

		$in{cdate} =~ s/(\d{2}):(\d{2}) (\d{2}).(\d{2}).(\d{4})/$cr_time = timelocal(0,$2,$1,$3,$4-1,$5-1900)/ge;
		unless (defined $cr_time)
		{
			&PrintHeader ("$Language{phrase26} #$in{uin}");
			&PrintMenu (30);
			print "UIN $in{uin}:$Language{phrase28}. $Language{phrase247}: <b>$in{cdate}</b>. $Language{phrase30}.";
			&PrintFooter;
			exit;

		}

		if ($in{'auth'}    ne "0") { $in{'auth'} = 1 };
		if ($in{'bcst'}    ne "1") { $in{'bcst'} = "0" };
		if ($in{'cpass'}   ne "1") { $in{'cpass'} = "0" };
		if ($in{'e1publ'}  ne "1") { $in{'e1publ'} = "0" };
		if ($in{'cr_time'} ne "0") { $in{'cr_time'} = 1 };

		$rv=$dbh->do("UPDATE users_info_ext SET pass='$in{pass}', llog='$llog_time', bcst='$in{bcst}', cdate='$cr_time', cpass='$in{cpass}', nick='$in{nick}', frst='$in{frst}', last='$in{last}', email1='$in{email1}', email2='$in{email2}', email3='$in{email3}', e1publ='$in{e1publ}', auth='$in{auth}', sex='$in{sex}', age='$in{age}', bday='$bday', bmon='$bmon', byear='$byear', notes='$in{notes}' where uin=$in{uin}");
		if ($rv != 1)
		{
			&PrintHeader ("$Language{phrase26} #$in{uin}");
			&PrintMenu (30);
			print "UIN $in{uin}:$Language{phrase28}. $Language{phrase30}.";
			&PrintFooter;
			exit;
		}
		&PrintHeader ("$Language{phrase32}: $in{uin}");
		&PrintMenu (30);
		print qq(<b>UIN $in{uin}: $Language{phrase32}.</b> <BR> <a href="isdwm.cgi?action=edituin&uin=$in{uin}">$Language{phrase33}.);
		&PrintFooter;
		exit;
	}
	$sth=$dbh->prepare("SELECT * from users_info_ext WHERE uin=$in{uin}");	
	$sth->execute;
	$Result = $sth->rows;
	if ($Result != 1) {
		&PrintHeader ("$Language{phrase34}!");
		&PrintMenu (30);
		printf ("<h2>$Language{phrase34}: $Language{phrase35}!</h2>", $in{uin});
		&PrintFooter; exit;
	}
	@rows=$sth -> fetchrow;
	&PrintHeader ("$Language{phrase36} #$in{uin}");
	&PrintMenu (30);
	&GetIP($rows[4]);
	print qq|
	<FORM ACTION="isdwm.cgi" METHOD="POST">
	<INPUT TYPE="hidden" NAME="action" VALUE="edituin">
	<INPUT TYPE="hidden" NAME="do" VALUE="submit">
	<INPUT TYPE="hidden" NAME="uin" VALUE="$rows[0]">
	<table border=0 bgcolor="$TableBorderColor" cellpadding="$RightTablesCellPadding" cellspacing="1" width="100%">
		<tr><td bgcolor="$TableColorStrip" colspan="2" align="center"><b>$Language{phrase36} #$rows[0]</b></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase1}:</td><td><INPUT TYPE="text" NAME="pass" VALUE="$rows[1]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase25}:</td><td><INPUT TYPE="text" NAME="nick" VALUE="$rows[8]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase49}:</td><td><INPUT TYPE="text" NAME="frst" VALUE="$rows[9]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase50}:</td><td><INPUT TYPE="text" NAME="last" VALUE="$rows[10]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase47}:</td><td><INPUT TYPE="text" NAME="cdate" VALUE="|; printf ("%02d:%02d %02d.%02d.%d",($t = localtime($rows[6]))->hour, $t->min, $t->mday, $t->mon+1, $t->year+1900); print qq|" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase37}:</td><td><INPUT TYPE="text" NAME="llog" VALUE="|; printf ("%02d:%02d %02d.%02d.%d",($t = localtime($rows[3]))->hour, $t->min, $t->mday, $t->mon+1, $t->year+1900); print qq|" $InputParam></td></tr>|;
		if ($rows[3] != 0) 
		{
			print qq|	
		<tr bgcolor="$TableColor"><td>$Language{phrase41}:</td><td>$rows[4]</td></tr>|;
		}
		print qq|
		<tr bgcolor="$TableColor"><td>$Language{phrase46}:</td><td><INPUT TYPE="CHECKBOX" NAME="bcst" VALUE="1"|; if ($rows[5] == 1) {print " checked";} print qq| $InputParam> $Language{phrase174}</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase48}:</td><td><INPUT TYPE="CHECKBOX" NAME="cpass" VALUE="1"|; if ($rows[7] == 1) {print " checked";} print qq| $InputParam> $Language{phrase174}</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase51} #1:</td><td><INPUT TYPE="text" NAME="email1" VALUE="$rows[11]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase51} #2:</td><td><INPUT TYPE="text" NAME="email2" VALUE="$rows[12]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase51} #3:</td><td><INPUT TYPE="text" NAME="email3" VALUE="$rows[13]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase52}:</td><td><INPUT TYPE="CHECKBOX" NAME="e1publ" VALUE="1"|; if ($rows[14] == 1) {print " checked";} print qq| $InputParam> $Language{phrase174}</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase53}:</td><td><INPUT TYPE="CHECKBOX" NAME="auth" VALUE="0"|; if ($rows[16] == 0) {print " checked";} print qq| $InputParam> $Language{phrase174}</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase54}:</td><td><INPUT TYPE="RADIO" NAME="sex" VALUE="1"|; if ($rows[17]==1) {print " checked";} print qq|> <INPUT TYPE="RADIO" NAME="sex" VALUE="2"|; if ($rows[17]==2) {print " checked";} print qq|> <INPUT TYPE="RADIO" NAME="sex" VALUE="0"|; if ($rows[17]==0) {print " checked";} print qq| $InputParam>?</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase55}:</td><td><INPUT TYPE="text" NAME="age" VALUE="$rows[18]" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase56}:</td><td><INPUT TYPE="text" NAME="bthd" VALUE="|; printf("%02d.%02d.%04d",$rows[19],$rows[20],$rows[21]+1900); print qq|" $InputParam></td></tr>
		<tr bgcolor="$TableColor"><td colspan=2>$Language{phrase57}:<BR><TEXTAREA NAME="notes" ROWS=4 COLS=50 $InputParam>$rows[35]</TEXTAREA></td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase27} <a href="isdwm.cgi?action=newlock&uin=$rows[0]">$Language{phrase38}:</td><td>|; if ($rows[2]==1) {print "$Language{phrase39}";} else {print "$Language{phrase40}"} print qq|</td></tr>
		<tr bgcolor="$TableColor"><td>$Language{phrase58}:</td><td><a href="isdwm.cgi?action=deluser&uin=$in{uin}">$Language{phrase60}</a> / <a href="isdwm.cgi?action=newlock&uin=$in{uin}">$Language{phrase61}</a></td></tr>
		<tr bgcolor="$TableColor"><td colspan="2" align="right"><INPUT TYPE="SUBMIT" VALUE=" $Language{phrase59} " $InputParam></td></tr>
	</table>
	</form>|;
	&PrintFooter; exit;
}
if ($in{action} eq "list") 
{
	&PrintHeader ("$Language{phrase62}");
	&PrintMenu (30);
	if ($in{sort} eq "nick") { $sort="ORDER BY nick" }
		elsif ($in{sort} eq "fname") { $sort="ORDER BY frst" }
			elsif ($in{sort} eq "lname") { $sort="ORDER BY last" }
				elsif ($in{sort} eq "email") { $sort="ORDER BY email1" }
					elsif ($in{sort} eq "llog") { $sort="ORDER BY llog" }
						else { $sort="ORDER BY uin" };

	if (!$in{page}) {$in{page}=0;} else {$in{page}--};

	$PageS = $in{page}+1;
	{
		$LIMIT = qq(LIMIT $MaxPageItems OFFSET ).$MaxPageItems*$in{page};
	}
	
	$sth=$dbh->prepare("SELECT COUNT(uin) from users_info_ext");
	$sth->execute;
	$TotalByQuery = $sth->fetchrow;
	$sth=$dbh->prepare("SELECT uin,nick,frst,last,pass,email1,llog from users_info_ext $sort $LIMIT");
	$sth->execute;
	$online=$dbh->prepare("SELECT uin, stat from online_users");
	$online->execute;
	$online_hash = $online -> fetchall_hashref('uin');
	for ($i = 1; $i<($TotalByQuery/$MaxPageItems)+1; $i++) 
	{
		if ($PageS != $i) 
		{
			$page .= qq(<a href="isdwm.cgi?action=list&sort=$in{sort}&page=$i"><b>$i</b></a> );
		}
			else
		{
			$page .= "<b>$i </b>";
		}

	}
	print qq(	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100%>
	<tr bgcolor=$TableColorStrip><td colspan=8 align="center"><b>$Language{phrase62}</b></td></tr>
	<FORM ACTION="isdwm.cgi" METHOD="GET">
	<tr bgcolor=$TableColorStrip><td colspan=8>$Language{phrase63}, UIN: <INPUT TYPE="hidden" NAME="action" VALUE="edituin"><INPUT TYPE="text" NAME="uin" SIZE="8" $InputParam> <INPUT TYPE="SUBMIT" VALUE="$Language{phrase90}" $InputParam></td></tr></form>
	<tr bgcolor=$TableColorStrip align="center"><td><a href="isdwm.cgi?action=list&sort=uin&page=1"><b>UIN</b></a></td><td><a href="isdwm.cgi?action=list&sort=nick&page=1"><b>$Language{phrase25}</b></a></td><td><a href="isdwm.cgi?action=list&sort=fname&page=1"><b>$Language{phrase49}</b></a></td><td><a href="isdwm.cgi?action=list&sort=lname&page=1"><b>$Language{phrase50}</b></a></td><td><b>$Language{phrase1}*</b></td><td><a href="isdwm.cgi?action=list&sort=email&page=1"><b>$Language{phrase51}</b></a></td><td><a href="isdwm.cgi?action=list&sort=llog&page=1"><b>$Language{phrase225}</b></a></td><td><img src="$URLToImages/status.gif" border=0 width="16" height="16" alt="$Language{phrase92}"></td></tr>);

	while($hash_ref = $sth->fetchrow_hashref) 
	{
		&WriteUser ($hash_ref->{uin}, $hash_ref->{nick}, $hash_ref->{frst}, $hash_ref->{last}, $hash_ref->{pass}, $hash_ref->{email1}, $hash_ref->{llog}, $online_hash->{$hash_ref->{uin}}->{stat});
	}

	print qq|<tr><td colspan=7>$Language{phrase19}: $page</td></tr>|;
	print qq|<tr><td colspan=7><small>* $Language{phrase64}</small></td></tr></table>|;
	&PrintFooter; exit;
}
if ($in{action} eq "adduser") 
{
	&PrintHeader ("$Language{phrase69}");
	&PrintMenu (20);
	if ($in{do} eq "submit") 
	{
		if ($in{'cpass'} eq "on") { $cpass= 1 } else { $cpass = 0 };
		if ($in{'auth'}  eq "on") { $auth = 0 } else { $auth  = 1 };

		$time=time;

		$dbh->{AutoCommit} = 0;
		$dbh->{RaiseError} = 1;
	

		eval {
			$sth=$dbh->do("INSERT INTO users_info_ext (uin, pass, nick, frst, last, email1, cdate, cpass, auth, sex) values ($in{uin}, '$in{password}', '$in{nick}', '$in{frst}', '$in{last}', '$in{email}', $time, $cpass, $auth, '$in{sex}')");

			if ($in{regreq} eq "true") 
			{
				$rv=$dbh->do("DELETE FROM register_requests WHERE uin=$in{ruin}");
			}

			$dbh->commit;
		};

		if ($@) {
			print "<b>$Language{phrase66}</b>";
			$dbh->rollback;
		} else {
			printf (qq(<b>$Language{phrase85}</b> <br><a href="isdwm.cgi?action=edituin&uin=$in{uin}">$Language{phrase81}), $in{uin});
		}

		if ($in{sendmail} eq "on") 
		{
			unless (($in{email} =~ /.*\@.*\..*/) || ($in{email} =~ tr/;<>*|`&$!#()[]{}:'"//))
			{
				print "<br>$Language{phrase72}";
			}
			else
			{
				unless (open (MAIL, "|$sendmailprog -t")) 
				{
					print qq(<br>$Language{phrase77} <b>$sendmailprog</b>. $Language{phrase78} <a href="isdwm.cgi?action=setup">$Language{phrase79}</a>!);
					&PrintFooter;
					exit
				};

				print MAIL "$MailHeader\n";
				print MAIL "To: $in{email}\n";
				print MAIL "From: $AdminMail\n";
				print MAIL "Subject: $MailRegSubject\n\n";
				$MailTextSubject =~ s/%uin%/$in{uin}/gi;
				$MailTextSubject =~ s/%pass%/$in{password}/gi;
				$MailTextSubject =~ s/%adminmail%/$AdminMail/gi;
				print MAIL "$MailTextSubject";
				close (MAIL);
			}
		}

		&PrintFooter;
		exit;
	}

	$MaxUIN = &GetFreeUIN;

	if ($in{'nick'}) { $default_nick = $in{'nick'}; }
	if ($in{'frst'}) { $default_frst = $in{'frst'}; }
	if ($in{'last'}) { $default_last = $in{'last'}; }
	if ($in{'last'}) { $default_last = $in{'last'}; }
	if ($in{'pass'}) { $default_pass = $in{'pass'}; }

	&PrintRegForm ($MaxUIN, $default_pass, $default_nick, $default_frst, $default_last, $in{'email1'}, $in{'sex'}, $in{'regreq'}, $in{'show_pass'}, $default_pass);
	&PrintFooter;
	exit;
};
if ($in{action} eq "regreq") 
{
	&PrintHeader ("$Language{phrase70}");
	&PrintMenu (70);
	if ($in{do} eq "delreq")
	{
		$rv=$dbh->do("DELETE FROM register_requests WHERE uin=$in{ruin}");
		if ($rv != 1)
		{
			print ("<b>$Language{phrase71} #$in{uin}</b>");
		}
		else
		{
			print qq(<b>$Language{phrase80}</b><br><br><a href="isdwm.cgi?action=regreq">$Language{phrase82}</a>);
		}
		&PrintFooter;
		exit;
	}

	$sth=$dbh->prepare("SELECT uin,nick,pass,frst,last,cdate,email1,notes,sex from register_requests");
	$sth->execute;
	$req=$sth->rows;

	print $sth->errstr if ($sth->errstr);

	print qq(<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100%>
	<tr bgcolor=$TableColorStrip><td colspan=7 align=center><b>$Language{phrase88} ($req)</b></td></tr>
	<tr bgcolor=$TableColorStrip><td width="1"><nobr>$Language{phrase89}</nobr></td><td width="1">$Language{phrase25}</td><td width="1">$Language{phrase49}</td><td width="1">$Language{phrase50}</td><td width="1"><nobr>e-mail</nobr></td><td>$Language{phrase191}:</td><td width="1">$Language{phrase209}</td></tr>);

	while($hash_ref = $sth->fetchrow_hashref) 
	{
		$date = sprintf ("%02d:%02d %02d.%02d.%d",($t = localtime($hash_ref->{cdate}))->hour, $t->min, $t->mday, $t->mon+1, $t->year+1900);
		print qq(<tr bgcolor=$TableColor>
			<td width="1">$date</td>
			<td width="1">$hash_ref->{nick}</td>
			<td width="1">$hash_ref->{frst}</td>
			<td width="1">$hash_ref->{last}</td>
			<td width="1">$hash_ref->{email}</td>
			<td>$hash_ref->{notes}</td>
			<td width="1"><a href="isdwm.cgi?action=adduser&nick=$hash_ref->{nick}&frst=$hash_ref->{frst}&last=$hash_ref->{last}&email1=$hash_ref->{email}&sex=$hash_ref->{sex}&pass=$hash_ref->{pass}&ruin=$hash_ref->{uin}&regreq=true&show_pass=1">$Language{phrase192}</a> <a href="isdwm.cgi?action=regreq&do=delreq&ruin=$hash_ref->{uin}">$Language{phrase60}</a></td></tr>);
	}
	print "</table>"; &PrintFooter; exit;
}

if ($in{action} eq "exit") 
{
	&ClearCookies ("adminuin", "adminpass");
	print "\n";
	&PrintEntryExit("$Language{phrase75}");
	print qq(<table><tr><td align=center><b>$Language{phrase73}</b><br>$Language{phrase74}<br><br>$Language{phrase83}.$Copyright<br>$Copyright_local</td></tr></table>);
	print <<HTML__;
</body>
</html>
HTML__
	exit;
}

if ($in{action} eq "lockchangetext") 
{
	&PrintHeader ("$Language{phrase84}");
	&PrintMenu(50);

	if (&DetectULockAdminTable)
	{
		$rv=$dbh->do("UPDATE admin_locktext SET admin_lck_text='$in{admin_lck_text}', admin_uin=$cook{adminuin} WHERE luin=$in{uin}");
                                                        
		if (($rv !=1) && ($in{'admin_lck_text'} ne ""))
		{
			$rv=$dbh->do("INSERT INTO admin_locktext VALUES ($in{uin}, $cook{adminuin}, '$in{admin_lck_text}')");
		}
	}

	$rv=$dbh->do("UPDATE users_lock SET lck_text='$in{lck_text}' WHERE luin=$in{uin}");

	if ($rv != 1)
	{
		printf ("<b>$Language{phrase91}<b>", $in{uin});
	}
	else
	{
		print "<b>UIN #$in{uin}: $Language{phrase93}</b><br><br>";
		print qq(<a href="isdwm.cgi?action=lockuser">$Language{phrase96}</a><br>
		<a href="isdwm.cgi?action=lockuser&do=lockedit&uin=$in{uin}">UIN #$in{uin}: $Language{phrase176}</a>);
	}

	&PrintFooter; exit;
}

if ($in{action} eq "newlock") 
{
	&PrintHeader ("$Language{phrase98}");
	&PrintMenu(60);

	if ($in{'do'} eq 'lock')
	{
		$rv=$dbh->do("UPDATE users_info_ext SET ulock=1 WHERE uin=$in{uin}");

		if ($rv != 1) 
		{
			printf ("$Language{phrase86}", $in{'uin'});
			&PrintFooter;
			exit;
		}

		if ($in{'lck_text'} ne "")
		{
			$rv=$dbh->do("UPDATE users_lock SET lck_text='$in{lck_text}' where luin=$in{uin}");
			if ($rv !=1) 
			{
				$rv=$dbh->do("INSERT INTO users_lock VALUES ($in{uin},'$in{lck_text}')");
			}			
		}

		if (&DetectULockAdminTable)
		{        
			$rv=$dbh->do("UPDATE admin_locktext SET admin_lck_text='$in{admin_lck_text}', admin_uin=$cook{adminuin} WHERE luin=$in{uin}");
                                                                
			if (($rv !=1) && ($in{'admin_lck_text'} ne "")) 
			{
				$rv=$dbh->do("INSERT INTO admin_locktext VALUES ($in{uin}, $cook{adminuin}, '$in{admin_lck_text}')");
			}
		}

		printf (qq(<b>$Language{phrase87}</b><br><br><a href="isdwm.cgi?action=lockuser">$Language{phrase193}</a>), $in{uin});
		&PrintFooter; exit;
	}

	unless (&DetectULockAdminTable)
	{
		$cr_text = qq|<br>[ <a href="isdwm.cgi?action=create_admin_lck_table">$Language{phrase243}</a> ]|;
	}
	else
	{
		$add_text = qq|<tr bgcolor=$TableColor><td>$Language{phrase242}:</td><td><TEXTAREA NAME="admin_lck_text" ROWS=5 COLS=50 $InputParam></TEXTAREA><br>[ <a href="isdwm.cgi?action=drop_admin_lck_table">$Language{phrase244}</a> ]</td></tr>|;
	}

	print qq(
	<FORM ACTION="isdwm.cgi" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="newlock">
	<INPUT TYPE="HIDDEN" NAME="do" VALUE="lock">
	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=200 align=center>
	<tr bgcolor=$TableColorStrip><td colspan=2 align=center><b>$Language{phrase194}</b></td></tr>
	<tr bgcolor=$TableColor><td>UIN:</td>
	<td><INPUT TYPE="TEXT" NAME="uin" VALUE="$in{uin}" size=7 $InputParam></td></tr>
	<tr bgcolor=$TableColor><td>$Language{phrase97}:</td><td><TEXTAREA NAME="lck_text" ROWS=5 COLS=50 $InputParam>$default_lock_text</TEXTAREA>$cr_text</td></tr>
	$add_text
	<tr bgcolor=$TableColor><td>&nbsp;</td><td><INPUT TYPE="SUBMIT" VALUE="$Language{phrase195}" $InputParam></td></tr></form></table>);
	&PrintFooter; exit;
}

if ($in{action} eq "lockremove")
{
	&PrintHeader ("$Language{phrase196}");
	&PrintMenu(50);

	$rv=$dbh->do("UPDATE users_info_ext SET ulock=0 where uin=$in{uin}");
	$rv=$dbh->do("DELETE FROM users_lock where luin=$in{uin}");

	if ($rv != 1)
	{
		print "UIN #$in{uin}: $Language{phrase95}<BR><br>";
	}

	print "<b>UIN #$in{uin}: $Language{phrase197}</b><br><br>";
	print qq(<a href="isdwm.cgi?action=lockuser">$Language{phrase198}</a></b>);
	&PrintFooter; exit;
}

if ($in{action} eq "lockuser")
{
	if ($in{'do'} eq 'lockedit')
	{
		&PrintHeader ("$Language{phrase177}");
		&PrintMenu(50);
		$sth=$dbh->prepare("SELECT i.uin,i.nick,i.frst,i.last,i.email1,l.lck_text FROM users_info_ext i, users_lock l WHERE i.uin=$in{uin} AND l.luin=i.uin");
		$sth->execute;

		if ($sth->rows !=1)
		{
			&PrintFooter;
			exit;
		}

		$hash_ref = $sth->fetchrow_hashref;

		print qq|
		<FORM ACTION="isdwm.cgi" METHOD="POST">
		<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100% align=center>
		<tr bgcolor=$TableColorStrip><td colspan=5 align=center><b>$Language{phrase199}</b></td></tr>
		<tr bgcolor=$TableColor><td><b>UIN</b></td><td><b>$Language{phrase25}</b></td><td><b>$Language{phrase49}</b></td><td><b>$Language{phrase50}</b></td><td><b>E-mail</b></td></tr>
		<tr bgcolor=$TableColor><td><a href="isdwm.cgi?action=edituin&uin=$hash_ref->{'uin'}">$hash_ref->{'uin'}</a></td><td>$hash_ref->{'nick'}</td><td>$hash_ref->{'frst'}</td><td>$hash_ref->{'last'}</td><td>$hash_ref->{'email'}</td></tr>
		<tr bgcolor=$TableColor><td colspan=5 align=left>
		<BR>$Language{phrase210}:<BR>
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="lockchangetext">
		<INPUT TYPE="HIDDEN" NAME="uin" VALUE="$hash_ref->{'uin'}">
		<TEXTAREA NAME="lck_text" ROWS=5 COLS=50 $InputParam>$hash_ref->{'lck_text'}</TEXTAREA>|;

		if (&DetectULockAdminTable)
		{
			my $sth=$dbh->prepare("SELECT * FROM admin_locktext WHERE luin=$hash_ref->{uin}");
			$sth->execute;

			$hash_ref = $sth->fetchrow_hashref;

			print qq|<br><br>$Language{phrase242} ($hash_ref->{'admin_uin'}):<br><TEXTAREA NAME="admin_lck_text" ROWS=5 COLS=50 $InputParam>$hash_ref->{'admin_lck_text'}</TEXTAREA><br>|;
		}

		print qq|<BR><INPUT TYPE="SUBMIT" VALUE="$Language{phrase219}" $InputParam> [ <a href="isdwm.cgi?action=lockremove&uin=$hash_ref->{'uin'}">$Language{phrase217}</a> \| <a href="isdwm.cgi?action=deluser&uin=$hash_ref->{'uin'}">$Language{phrase67}</a> ]
		</td></tr></table></FORM>|;
		&PrintFooter; exit;
	}

	&PrintHeader ("$Language{phrase189}");
	&PrintMenu(50);

	$sth=$dbh->prepare("SELECT i.uin,i.nick,i.frst,i.last,i.email1,l.lck_text FROM users_info_ext i, users_lock l WHERE l.luin=i.uin");
	$sth->execute;
	$count=$sth->rows;

	print qq|
	<FORM ACTION="isdwm.cgi" METHOD="POST"><INPUT TYPE="HIDDEN" NAME="action" VALUE="dobanuser">
	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=100% align=center>
	<tr bgcolor=$TableColorStrip><td colspan=7 align=center><b>$Language{phrase190} ($count)</b></td></tr>|;

	if ($count != 0) {
		print qq|<tr bgcolor=$TableColor align=center><td width="1">UIN</td><td width="1">$Language{phrase25}</td><td width="1">$Language{phrase49}</td><td width="1">$Language{phrase50}</td><td width="1"><nobr>E-mail</nobr></td><td>$Language{phrase200}</td><td width="1"><nobr>$Language{phrase201}</nobr></td></tr>|;

		while($hash_ref = $sth->fetchrow_hashref) 
		{

			my $add_text;

			if (&DetectULockAdminTable)
			{
				my $sth=$dbh->prepare("SELECT * FROM admin_locktext WHERE luin=$hash_ref->{uin}");
				$sth->execute;

				$hash_info = $sth->fetchrow_hashref;

				$add_text =  qq|<br><i>$hash_info->{'admin_uin'}: $hash_info->{'admin_lck_text'}<i>| if ($hash_info->{'admin_lck_text'});
			}

			print qq(<tr bgcolor=$TableColor><td>$hash_ref->{'uin'}</td><td>$hash_ref->{'nick'}</td><td>$hash_ref->{'frst'}</td><td>$hash_ref->{'last'}</td><td>$hash_ref->{'email'}</td><td>$hash_ref->{'lck_text'}$add_text</td><td width="1"><a href="isdwm.cgi?action=lockuser&do=lockedit&uin=$hash_ref->{'uin'}">$Language{phrase178}</a></td></tr>);
		}
	}
	else
	{
		print qq(<tr bgcolor=$TableColor><td colspan=7 align=center><b>$Language{phrase23}</b></td></tr>);
	}

	print "</table>";
	&PrintFooter;
	exit;
}

if ($in{action} eq "setup") 
{
	&Setup;
}

if ($in{action} eq "deluser") 
{
	if (($in{do} eq "delete") || ($in{del} eq "delete"))
	{
		&PrintHeader ("$Language{phrase179} #$in{uin}");
		&PrintMenu(40);
		if ($in{uin} =~ /\D/) 
		{
			print "$Language{phrase180}";
			&PrintFooter;
			exit;
		}

		$rv=$dbh->do("DELETE FROM users_info_ext WHERE uin=$in{uin}");

		if ($rv != 1)
		{
			print "UIN #$in{uin}: $Language{phrase181}";
		}
			else
		{
			$rv=$dbh->do("DELETE FROM users_messages WHERE to_uin=$in{uin} OR from_uin=$in{uin}");
			$rv=$dbh->do("DELETE FROM users_lock WHERE luin=$in{uin}");
			print qq(<b>#$in{uin}: $Language{phrase182}</b><br><br><a href="isdwm.cgi?action=list">$Language{phrase202}</a>);
		}
		&PrintFooter;
		exit;
	}

	if ($in{do} eq "confirm")
	{
		&PrintHeader ("#$in{uin}: $Language{phrase183}");
		&PrintMenu(40);
		$sth=$dbh->prepare("SELECT nick,frst,last,email1,llog FROM users_info_ext WHERE uin=$in{uin}");
		$sth->execute;
		@row=$sth -> fetchrow;
		if (@row ==0) {print "{phrase203}"; print @Footer; exit;}
		print qq(
		<FORM ACTION="isdwm.cgi" METHOD="GET">
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="deluser">
		<INPUT TYPE="HIDDEN" NAME="do" VALUE="delete">
		<INPUT TYPE="HIDDEN" NAME="uin" VALUE="$in{uin}">
		<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=450 align=center>
		<tr bgcolor=$TableColorStrip><td colspan=7 align=center><b>#$in{uin}: $Language{phrase183}</b></td></tr>
		<tr bgcolor=$TableColor align=center><td>$Language{phrase25}</td><td>$Language{phrase49}</td><td>$Language{phrase50}</td><td>E-mail</td><td>$Language{phrase211}</td></tr>
	        <tr bgcolor=$TableColor><td>$row[0]</td><td>$row[1]</td><td>$row[2]</td><td>$row[3]</td><td align="right">); printf ("%02d:%02d %02d.%02d.%d",($t = localtime($rows[6]))->hour, $t->min, $t->mday, $t->mon+1, $t->year+1900); print qq(</td></tr>
		<tr bgcolor=$TableColor><td colspan=5 align=center><INPUT TYPE="SUBMIT" TYPE="NAME" VALUE="$Language{phrase60}" $InputParam></td></tr></form></td></tr></table>);
		&PrintFooter;
		exit;
	}
	&PrintHeader ("$Language{phrase184}");
	&PrintMenu(40);
	print qq(
	<FORM ACTION="isdwm.cgi" METHOD="GET">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="deluser">
	<INPUT TYPE="HIDDEN" NAME="do" VALUE="confirm">
	<table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=350 align=center>
	<tr bgcolor=$TableColorStrip><td colspan=7 align=center><b>$Language{phrase184}</b></td></tr>
	<tr bgcolor=$TableColor><td>$Language{phrase185}:</td><td><INPUT TYPE="TEXT" SIZE=8 VALUE="$in{uin}" NAME="uin" $InputParam>
	<INPUT TYPE="SUBMIT" TYPE="NAME" VALUE="$Language{phrase218}" $InputParam><br><INPUT TYPE="CHECKBOX" NAME="del" value="delete" $InputParam> $Language{phrase68}</td></tr>
	</table>
	</FORM>);
	&PrintFooter;
	exit;
}
#########################################################################
#			MAIN PAGE
#########################################################################

	&PrintHeader ("$Language{phrase204}");
	&PrintMenu;
       	$sth=$dbh->prepare("SELECT COUNT (uin) from users_info_ext");
       	$sth->execute;
       	$TotalCount = $sth->fetchrow_array;
       	$sth=$dbh->prepare("SELECT COUNT (uin) from online_users");
       	$sth->execute;
       	$OnlineCount = $sth->fetchrow_array;
       	$sth=$dbh->prepare("SELECT COUNT (uin) FROM register_requests");
       	$sth->execute;
       	$RRequestCount = $sth->fetchrow_array;
       	$sth=$dbh->prepare("SELECT COUNT (to_uin) FROM users_messages");
       	$sth->execute;
       	$MessagesCount= $sth->fetchrow_array;
       	$sth=$dbh->prepare("SELECT COUNT (ulock) FROM users_info_ext where ulock=1");
       	$sth->execute;
       	$UlockCount= $sth->fetchrow_array;
	
       	unless (-f $ISD_pid) { $iserverd_status = "$Language{phrase205}" }
       		else { $iserverd_status = "$Language{phrase206}" };

       	print <<HTML__;
       <table border=0 bgcolor=$TableBorderColor cellpadding="$RightTablesCellPadding" cellspacing=1 width=420 valign="center">
       	<tr bgcolor=$TableColorStrip><td colspan=2 align=center><b>$Language{phrase169}:</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase102}:</td><td><b>$iserverd_status</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase103}:</td><td><b>$TotalCount</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase104}:</td><td><b>$OnlineCount</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase105}:</td><td><b>$RRequestCount</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase106}:</td><td><b>$MessagesCount</b></td></tr>
       	<tr bgcolor=$TableColor><td>$Language{phrase107}:</td><td><b>$UlockCount</b></td></tr>
       </table>
HTML__

	&PrintFooter;
	exit;